<?php
/*
Plugin Name: Tango Smileys Extended
Plugin URI: http://munashiku.slightofmind.net/wordpress-plugins/tango-smileys-extended
Description: Replace the standard WP Smileys with Tango PNG smileys. Extends smileys from 18 to 202! <strong>For WordPress 2.8+</strong>
Version: 2.7.0.0
Author: Whesley McCabe
Author URI: http://munashiku.slightofmind.net/
*/

/*
#	This file provides structure for Tango Smileys Extended.
#	Please do not edit this file.
*/

// Provide Upgrade Version
global $tse_version;
$tse_version = '2700';

// Get Includes
include_once( 'tse-options.php' );
include_once( 'tse-magic.php' );
include_once( 'tse-comments.php' );
include_once( 'tse-mcecomments.php' );

// Ozh Admin Drop Down Menu: TSE Icon
function tse_icon( $hook ) {
	if ( $hook == 'tango-smileys-extended' ) return plugins_url( 'tseicon.png', __FILE__ );
	return $hook;
}
add_filter( 'ozh_adminmenu_icon_tango-smileys-extended', 'tse_icon' );

// Filters & Actions: Enable / Disable
function tse_filters() {
	$tse = get_option( 'tango_smileys_extended' );
	if ( $tse['posts'] || $tse['pages'] ) {
		update_option( 'use_smilies', 0 );
		add_filter( 'the_content', 'tse_conditional', 500 );
		add_action( 'admin_head', 'tse_htmled_css' );
		add_action( 'admin_footer', 'tse_htmled_script' );
		add_action( 'init', 'tse_tinymce_addbuttons' );
	}
	if ( $tse['comments'] ) {
		update_option( 'use_smilies', 0 );
		add_filter( 'comment_text', 'tse_switcher', 500 );
		if ( $tse['comments_cti'] ) {
			if ( $tse['comments_mce'] ) {
				add_action( 'comment_form', 'tse_add_mce_smileys' );
				add_action( 'wp_head', 'tse_mcestyle' );
				add_action( 'template_redirect', 'tse_mce_jquery' );
			}
			else {
				add_action( 'comment_form', 'tse_add_cti_smileys' );
				add_action( 'wp_head', 'tse_ctistyle' );
			}
		}
	}
}

// TSEPOP.JS TEST
function tse_tinymce_popup() {
	$url = get_bloginfo('wpurl') . '/wp-includes/js/tinymce/tiny_mce_popup.js';
	wp_enqueue_script( 'tinymce_popup', $url );
}

// Post or Page editor?
function tse_check_postpage() {
	global $pagenow;
	$tse = get_option( 'tango_smileys_extended' );
	if ( $tse['posts_cti'] || $tse['page_cti'] ) {
		$ed = ( in_array( $pagenow, array( 'post.php', 'post-new.php', 'page.php', 'page-new.php' ) ) );
	}
	return $ed;
}

// Add TSE to the TinyMCE plugin list and add a button
function tse_tinymce_addbuttons() {
	if ( !current_user_can( 'edit_posts' ) && !current_user_can( 'edit_pages' ) ) {
		return;
	}
	if ( get_user_option( 'rich_editing' ) == 'true' ) {
		if ( tse_check_postpage() ) {
			add_filter( 'mce_external_plugins', 'tse_tinymce_addplugin' );
			add_filter( 'mce_buttons', 'tse_tinymce_registerbutton' );
		}
	}
}
function tse_tinymce_registerbutton( $buttons ) {
	array_push( $buttons, 'separator', 'tse' );
	return $buttons;
}
function tse_tinymce_addplugin( $plugin_array ) {
	$tse = get_option( 'tango_smileys_extended' );
	$url = get_bloginfo('wpurl') . '/wp-includes/js/tinymce/tiny_mce_popup.js';
	$params = '?smileysize=' . $tse['smileysize'] . '&tsepop=' . rawurlencode( $url );
	$plugin_array['tse'] = plugins_url( "tse-mce-plugin.php{$params}", __FILE__ );
	return $plugin_array;
}

// Add TSE to the HTML editor for posts and pages.
function tse_htmled_css() {
	if ( tse_check_postpage() ) {
		$icon = plugins_url( 'tseicon.png', __FILE__ );
echo <<<CSS
	<style type='text/css'>
		#ed_tse {
			background: url($icon) no-repeat center center !important;
		}
		#tse_htmled_smileys {
			border-color: #ccc !important;
			height: 260px;
			left: 0px;
			position: absolute;
			top: 0px;
			visibility: hidden;
			width: 368px;
		}
		#tse_htmled_smileys .inside {
			height: 220px;
			overflow: auto;
			position: absolute;
		}
		.htmlcti {
			padding: 4px !important;
			text-align: center;
		}
		.htmlcti img {
			padding: 1px;
		}
		.tse_title {
			background: #dfdfdf;
			font-size: 12px;
			font-weight: bold;
			padding: 6px;
			text-align: center;
			text-shadow: #fff 0 1px 0;
			-moz-border-radius: 6px 6px 0 0;
			-webkit-border-top-right-radius: 6px;
			-webkit-border-top-left-radius: 6px;
			-khtml-border-top-right-radius: 6px;
			-khtml-border-top-left-radius: 6px;
			border-top-right-radius: 6px;
			border-top-left-radius: 6px;
		}
	</style>
CSS;
	}
}
function tse_htmled_script() {
	$tse = get_option( 'tango_smileys_extended' );
	if ( tse_check_postpage() ) {
		echo '<script language="javascript" type="text/javascript" src="' . plugins_url( 'tse-htmled.js', __FILE__ ) . '"></script>';
		echo "<div id='tse_htmled_smileys' class='postbox'><div class='tse_title'>Tango Smileys Extended</div><div class='inside htmlcti'>";
		tse_cti_anywhere( 'content', true, 'all' );
		echo "</div></div>";
echo <<<SCRIPT
	<script language="javascript" type="text/javascript">
	//<![CDATA[
		if(document.getElementById("ed_toolbar")){
			qt_toolbar = document.getElementById("ed_toolbar");
			edButtons[edButtons.length] = new edButton("ed_tse","Tango Smileys", "", "", "");
			var qt_button = qt_toolbar.lastChild;
			while (qt_button.nodeType != 1){
				qt_button = qt_button.previousSibling;
			}
			qt_button = qt_button.cloneNode(true);
			qt_button.value = " ";
			qt_button.title = "Tango Smileys";
			qt_button.onclick = function () {}
			qt_button.id = "ed_tse";
			qt_toolbar.appendChild(qt_button);
		}
		at_attach("ed_tse", "tse_htmled_smileys", "click", "y", "pointer");
	//]]>
	</script>
SCRIPT;
	}
}

// Convert shorthand in posts and/or pages?
function tse_conditional( $tse_content ) {
	global $wp_query;
	$tse = get_option( 'tango_smileys_extended' );
	$tse_ispage = $wp_query->is_page;
	$tse_content = ( ( !$tse_ispage && $tse['posts'] ) || ( $tse_ispage && $tse['pages'] ) ) ? tse_switcher( $tse_content ) : $tse_content;
	return $tse_content;
}

// Activate or Upgrade Options
function tse_activate() {
	global $tse_version;
	$tse_old = get_option( 'tango_smileys_extended' );
	if ( !is_array( $tse_old ) || array_key_exists( 'tse_cti_bordert', $tse_old ) ) {
		delete_option( 'tango_smileys_extended' );
		$tse = array(
			'version'      => $tse_version,
			'wp_smilies'   => '',
			'posts'        => 1,
			'pages'        => 1,
			'comments'     => 1,
			'smileysize'   => '16',
			'posts_cti'    => 1,
			'pages_cti'    => 1,
			'comments_cti' => 1,
			'comments_mce' => '',
			'cti_width'    => '420',
			'cti_height'   => '36',
			'cti_bg'       => 'transparent',
			'cti_borders'  => '0',
			'cti_bordert'  => 'solid',
			'cti_borderc'  => 'black',
			'cti_header'   => 'Click to Insert Smiley',
			'standard'     => 1,
			'extended'     => 1,
			'gestures'     => 1,
			'special'      => 1,
			'animals'      => 1,
			'foodndrink'   => 1,
			'other'        => 1
		);
	}
	else {
		$tse = $tse_old;
		if ( !array_key_exists( 'smileysize', $tse ) ) {
			$tse['smileysize'] = '16';
		}
		if ( $tse['comments_cti'] ) {
			$groups = array( 'standard', 'extended', 'gestures', 'special', 'animals', 'foodndrink', 'other' );
			foreach ( $groups as $group ) {
				if ( !array_key_exists( $group, $tse ) ) {
					$tse[$group] = 1;
				}
			}
		}
		foreach ( $tse as $option => $value ) {
			if ( $tse[$option] == 'on' ) {
				$tse[$option] = 1;
			}
		}
	}
	update_option( 'tango_smileys_extended', $tse );
}
register_activation_hook( __FILE__, 'tse_activate' );

function tse_error() {
	update_option( 'tse_error',  ob_get_contents() );
}
add_action( 'activated_plugin', 'tse_error' );

tse_filters();
?>